﻿using Ageev_Exam_Tour.Model;
using Ageev_Exam_Tour.Pages;
using System;
using System.Collections.Generic;
using System.Data.Entity.Migrations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Ageev_Exam_Tour.Windows
{
    class HotelDTO 
    {
        int id;
        public int Id { get => id; set => id = value; }

        string name;
        public string Name { get => name; set => name = value; }

        int countOfStars;
        public int CountOfStart { get => countOfStars; set => countOfStars = value; }

        string countryCode;
        public string CountyCode { get => countryCode; set => countryCode = value; }

        string description;
        public string Description { get => description; set => description = value; }

        public HotelDTO(Hotel hotel)
        {
            Id = 0;
            Name = string.Empty;
            CountOfStart = 0;
            CountyCode = string.Empty;
            Description = string.Empty;
        }

    }

    /// <summary>
    /// Логика взаимодействия для wHotelActions.xaml
    /// </summary>
    public partial class wHotelActions : Window
    {
        private Hotel hotel;

        private List<Country> country;

        public List<Country> Countries { get => country; 
            set => country = value; }

        int[] stars = new int[] { 0, 1, 2, 3, 4, 5 };

        
        private HotelDTO myDTo = null;

        public wHotelActions()
        {

            // Чтобы взаимодейтсвовать с компонентами их изначально нужно инциализиорвать
            InitializeComponent();

            // Вытягиваю отели и редактирую

            Countries = GeneralData.myDataBase.Country.ToList();

            Country zeroValue = new Country { Code = "NU", Name = "Выбирите страну" };
            country.Add(zeroValue);
            Countries = country.OrderBy(x => x.Name).ToList();

            cbCountryCode.ItemsSource = Countries;
            cbCountryCode.SelectedItem = zeroValue;

            cbCountOfStart.ItemsSource = stars;

            HotelDTO dTO = new HotelDTO(hotel); // переделать

            myDTo = dTO;

            // Добавить функционал добавления

            DataContext = dTO; // Добавляем поля объекта Hotel
        }

        public wHotelActions(Hotel hotel)
        {
            this.hotel = hotel;
            InitializeComponent();

            cbCountOfStart.ItemsSource = stars;
            cbCountOfStart.SelectedValue = hotel.CountOfStars;

            Countries = GeneralData.myDataBase.Country.ToList().OrderBy(x => x.Name).ToList();
            cbCountryCode.ItemsSource = Countries;

            string countryName = hotel.Country.Name;
            cbCountryCode.SelectedItem = Countries.FirstOrDefault(x => x.Name ==  hotel.Country.Name);
      
            DataContext = hotel;
        }      
        
        
        private void BtnBackToPage(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
        }

        private void BtnSaveChanges(object sender, RoutedEventArgs e)
        {
            if (hotel != null)
            {
                MessageBox.Show($"{hotel.Name} {hotel.Country} {hotel.CountryCode}  {hotel.CountOfStars}");


            }
            else if (myDTo != null)
            {
                myDTo.CountOfStart = Convert.ToInt32(cbCountOfStart.SelectedItem);
                Country country = (Country)cbCountryCode.SelectedItem;

                Hotel hotel = new Hotel();
                hotel.Name = myDTo.Name;
                hotel.Country = country;
                hotel.Description = myDTo.Description;
                hotel.CountOfStars = myDTo.CountOfStart;
                hotel.CountryCode = country.Code;

                GeneralData.myDataBase.Hotel.Add( hotel );
                GeneralData.myDataBase.SaveChanges();

                DialogResult = true;
            }

            GeneralData.mainFrame.Navigate(new pgHotels());
        }
    }
}
